/* board-view-gtk.c generated by valac 0.54.8, the Vala compiler
 * generated from board-view-gtk.vala, do not modify */

/*
 * Copyright (C) 2018 Robert Roth
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>

#define BOARD_VIEW_GTK_MIN_TOGGLE_SIZE 48
#define BOARD_VIEW_size 5
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BOARD_VIEW (board_view_get_type ())
#define BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW, BoardView))
#define IS_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW))
#define BOARD_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BOARD_VIEW, BoardViewIface))

typedef struct _BoardView BoardView;
typedef struct _BoardViewIface BoardViewIface;

#define TYPE_PUZZLE_GENERATOR (puzzle_generator_get_type ())
#define PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGenerator))
#define PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))
#define IS_PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_GENERATOR))
#define IS_PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_GENERATOR))
#define PUZZLE_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))

typedef struct _PuzzleGenerator PuzzleGenerator;
typedef struct _PuzzleGeneratorClass PuzzleGeneratorClass;

#define TYPE_BOARD_VIEW_GTK (board_view_gtk_get_type ())
#define BOARD_VIEW_GTK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW_GTK, BoardViewGtk))
#define BOARD_VIEW_GTK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD_VIEW_GTK, BoardViewGtkClass))
#define IS_BOARD_VIEW_GTK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW_GTK))
#define IS_BOARD_VIEW_GTK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD_VIEW_GTK))
#define BOARD_VIEW_GTK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD_VIEW_GTK, BoardViewGtkClass))

typedef struct _BoardViewGtk BoardViewGtk;
typedef struct _BoardViewGtkClass BoardViewGtkClass;
typedef struct _BoardViewGtkPrivate BoardViewGtkPrivate;
enum  {
	BOARD_VIEW_GTK_0_PROPERTY,
	BOARD_VIEW_GTK_NUM_PROPERTIES
};
static GParamSpec* board_view_gtk_properties[BOARD_VIEW_GTK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BoardViewIface {
	GTypeInterface parent_iface;
	gint (*get_moves) (BoardView* self);
	PuzzleGenerator* (*get_puzzle_generator) (BoardView* self);
	void (*clear_level) (BoardView* self);
	void (*toggle_light) (BoardView* self, gint x, gint y, gboolean user_initiated);
	void (*increase_moves) (BoardView* self);
	gboolean (*is_light_active) (BoardView* self, gint x, gint y);
	GObject* (*get_light_at) (BoardView* self, gint x, gint y);
};

struct _BoardViewGtk {
	GtkGrid parent_instance;
	BoardViewGtkPrivate * priv;
};

struct _BoardViewGtkClass {
	GtkGridClass parent_class;
};

struct _BoardViewGtkPrivate {
	PuzzleGenerator* puzzle_generator;
	GtkToggleButton** lights;
	gint lights_length1;
	gint lights_length2;
	gint _moves;
};

static gint BoardViewGtk_private_offset;
static gpointer board_view_gtk_parent_class = NULL;
static BoardViewIface * board_view_gtk_board_view_parent_iface = NULL;

VALA_EXTERN GType puzzle_generator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleGenerator, g_object_unref)
VALA_EXTERN GType board_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoardView, g_object_unref)
VALA_EXTERN GType board_view_gtk_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoardViewGtk, g_object_unref)
static gint board_view_gtk_real_get_moves (BoardView* base);
static void board_view_gtk_real_toggle_light (BoardView* base,
                                       gint x,
                                       gint y,
                                       gboolean clicked);
static void __lambda4_ (BoardViewGtk* self,
                 GtkWidget* light);
VALA_EXTERN void board_view_handle_toggle (BoardView* self,
                               GObject* light);
static void _board_view_handle_toggle_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                          gpointer self);
static void ___lambda4__gtk_callback (GtkWidget* widget,
                               gpointer self);
static void __lambda5_ (BoardViewGtk* self,
                 GtkWidget* light);
static void ___lambda5__gtk_callback (GtkWidget* widget,
                               gpointer self);
static void board_view_gtk_real_clear_level (BoardView* base);
static PuzzleGenerator* board_view_gtk_real_get_puzzle_generator (BoardView* base);
static gboolean board_view_gtk_real_is_light_active (BoardView* base,
                                              gint x,
                                              gint y);
static GObject* board_view_gtk_real_get_light_at (BoardView* base,
                                           gint x,
                                           gint y);
static void board_view_gtk_real_increase_moves (BoardView* base);
VALA_EXTERN BoardViewGtk* board_view_gtk_new (void);
VALA_EXTERN BoardViewGtk* board_view_gtk_construct (GType object_type);
static GObject * board_view_gtk_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
VALA_EXTERN PuzzleGenerator* puzzle_generator_new (gint size);
VALA_EXTERN PuzzleGenerator* puzzle_generator_construct (GType object_type,
                                             gint size);
static void _board_view_gtk___lambda6_ (BoardViewGtk* self);
static void __board_view_gtk___lambda6__board_view_completed (BoardView* _sender,
                                                       gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN gint board_view_get_moves (BoardView* self);
VALA_EXTERN void board_view_toggle_light (BoardView* self,
                              gint x,
                              gint y,
                              gboolean user_initiated);
VALA_EXTERN void board_view_clear_level (BoardView* self);
VALA_EXTERN PuzzleGenerator* board_view_get_puzzle_generator (BoardView* self);
VALA_EXTERN gboolean board_view_is_light_active (BoardView* self,
                                     gint x,
                                     gint y);
VALA_EXTERN GObject* board_view_get_light_at (BoardView* self,
                                  gint x,
                                  gint y);
VALA_EXTERN void board_view_increase_moves (BoardView* self);
static void board_view_gtk_finalize (GObject * obj);
static GType board_view_gtk_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
board_view_gtk_get_instance_private (BoardViewGtk* self)
{
	return G_STRUCT_MEMBER_P (self, BoardViewGtk_private_offset);
}

static gint
board_view_gtk_real_get_moves (BoardView* base)
{
	BoardViewGtk * self;
	gint result = 0;
	self = (BoardViewGtk*) base;
	result = self->priv->_moves;
	return result;
}

static void
_board_view_handle_toggle_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                     gpointer self)
{
	board_view_handle_toggle ((BoardView*) self, _sender);
}

static void
__lambda4_ (BoardViewGtk* self,
            GtkWidget* light)
{
	guint _tmp0_;
	g_return_if_fail (light != NULL);
	g_signal_parse_name ("toggled", gtk_toggle_button_get_type (), &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (light, gtk_toggle_button_get_type (), GtkToggleButton), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _board_view_handle_toggle_gtk_toggle_button_toggled, (BoardView*) self);
}

static void
___lambda4__gtk_callback (GtkWidget* widget,
                          gpointer self)
{
	__lambda4_ ((BoardViewGtk*) self, widget);
}

static void
__lambda5_ (BoardViewGtk* self,
            GtkWidget* light)
{
	g_return_if_fail (light != NULL);
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (light, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) _board_view_handle_toggle_gtk_toggle_button_toggled, (BoardView*) self, 0);
}

static void
___lambda5__gtk_callback (GtkWidget* widget,
                          gpointer self)
{
	__lambda5_ ((BoardViewGtk*) self, widget);
}

static void
board_view_gtk_real_toggle_light (BoardView* base,
                                  gint x,
                                  gint y,
                                  gboolean clicked)
{
	BoardViewGtk * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	self = (BoardViewGtk*) base;
	gtk_container_foreach ((GtkContainer*) self, ___lambda4__gtk_callback, self);
	if (x >= BOARD_VIEW_size) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = y >= BOARD_VIEW_size;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = x < 0;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = y < 0;
	}
	if (_tmp0_) {
		return;
	}
	if ((((gint) x) + 1) < BOARD_VIEW_size) {
		GtkToggleButton** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		GtkToggleButton* _tmp4_;
		GtkToggleButton** _tmp5_;
		gint _tmp5__length1;
		gint _tmp5__length2;
		GtkToggleButton* _tmp6_;
		_tmp3_ = self->priv->lights;
		_tmp3__length1 = self->priv->lights_length1;
		_tmp3__length2 = self->priv->lights_length2;
		_tmp4_ = _tmp3_[((((gint) x) + 1) * _tmp3__length2) + ((gint) y)];
		_tmp5_ = self->priv->lights;
		_tmp5__length1 = self->priv->lights_length1;
		_tmp5__length2 = self->priv->lights_length2;
		_tmp6_ = _tmp5_[((((gint) x) + 1) * _tmp5__length2) + ((gint) y)];
		gtk_toggle_button_set_active (_tmp4_, !gtk_toggle_button_get_active (_tmp6_));
	}
	if ((((gint) x) - 1) >= 0) {
		GtkToggleButton** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		GtkToggleButton* _tmp8_;
		GtkToggleButton** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		GtkToggleButton* _tmp10_;
		_tmp7_ = self->priv->lights;
		_tmp7__length1 = self->priv->lights_length1;
		_tmp7__length2 = self->priv->lights_length2;
		_tmp8_ = _tmp7_[((((gint) x) - 1) * _tmp7__length2) + ((gint) y)];
		_tmp9_ = self->priv->lights;
		_tmp9__length1 = self->priv->lights_length1;
		_tmp9__length2 = self->priv->lights_length2;
		_tmp10_ = _tmp9_[((((gint) x) - 1) * _tmp9__length2) + ((gint) y)];
		gtk_toggle_button_set_active (_tmp8_, !gtk_toggle_button_get_active (_tmp10_));
	}
	if ((((gint) y) + 1) < BOARD_VIEW_size) {
		GtkToggleButton** _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		GtkToggleButton* _tmp12_;
		GtkToggleButton** _tmp13_;
		gint _tmp13__length1;
		gint _tmp13__length2;
		GtkToggleButton* _tmp14_;
		_tmp11_ = self->priv->lights;
		_tmp11__length1 = self->priv->lights_length1;
		_tmp11__length2 = self->priv->lights_length2;
		_tmp12_ = _tmp11_[(((gint) x) * _tmp11__length2) + (((gint) y) + 1)];
		_tmp13_ = self->priv->lights;
		_tmp13__length1 = self->priv->lights_length1;
		_tmp13__length2 = self->priv->lights_length2;
		_tmp14_ = _tmp13_[(((gint) x) * _tmp13__length2) + (((gint) y) + 1)];
		gtk_toggle_button_set_active (_tmp12_, !gtk_toggle_button_get_active (_tmp14_));
	}
	if ((((gint) y) - 1) >= 0) {
		GtkToggleButton** _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		GtkToggleButton* _tmp16_;
		GtkToggleButton** _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		GtkToggleButton* _tmp18_;
		_tmp15_ = self->priv->lights;
		_tmp15__length1 = self->priv->lights_length1;
		_tmp15__length2 = self->priv->lights_length2;
		_tmp16_ = _tmp15_[(((gint) x) * _tmp15__length2) + (((gint) y) - 1)];
		_tmp17_ = self->priv->lights;
		_tmp17__length1 = self->priv->lights_length1;
		_tmp17__length2 = self->priv->lights_length2;
		_tmp18_ = _tmp17_[(((gint) x) * _tmp17__length2) + (((gint) y) - 1)];
		gtk_toggle_button_set_active (_tmp16_, !gtk_toggle_button_get_active (_tmp18_));
	}
	if (!clicked) {
		GtkToggleButton** _tmp19_;
		gint _tmp19__length1;
		gint _tmp19__length2;
		GtkToggleButton* _tmp20_;
		GtkToggleButton** _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
		GtkToggleButton* _tmp22_;
		_tmp19_ = self->priv->lights;
		_tmp19__length1 = self->priv->lights_length1;
		_tmp19__length2 = self->priv->lights_length2;
		_tmp20_ = _tmp19_[(((gint) x) * _tmp19__length2) + ((gint) y)];
		_tmp21_ = self->priv->lights;
		_tmp21__length1 = self->priv->lights_length1;
		_tmp21__length2 = self->priv->lights_length2;
		_tmp22_ = _tmp21_[(((gint) x) * _tmp21__length2) + ((gint) y)];
		gtk_toggle_button_set_active (_tmp20_, !gtk_toggle_button_get_active (_tmp22_));
	}
	gtk_container_foreach ((GtkContainer*) self, ___lambda5__gtk_callback, self);
}

static void
board_view_gtk_real_clear_level (BoardView* base)
{
	BoardViewGtk * self;
	self = (BoardViewGtk*) base;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < BOARD_VIEW_size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							GtkToggleButton** _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							GtkToggleButton* _tmp5_;
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = y;
								y = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(y < BOARD_VIEW_size)) {
								break;
							}
							_tmp4_ = self->priv->lights;
							_tmp4__length1 = self->priv->lights_length1;
							_tmp4__length2 = self->priv->lights_length2;
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
							gtk_toggle_button_set_active (_tmp5_, FALSE);
						}
					}
				}
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static PuzzleGenerator*
board_view_gtk_real_get_puzzle_generator (BoardView* base)
{
	BoardViewGtk * self;
	PuzzleGenerator* _tmp0_;
	PuzzleGenerator* _tmp1_;
	PuzzleGenerator* result = NULL;
	self = (BoardViewGtk*) base;
	_tmp0_ = self->priv->puzzle_generator;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static gboolean
board_view_gtk_real_is_light_active (BoardView* base,
                                     gint x,
                                     gint y)
{
	BoardViewGtk * self;
	GtkToggleButton** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
	self = (BoardViewGtk*) base;
	_tmp0_ = self->priv->lights;
	_tmp0__length1 = self->priv->lights_length1;
	_tmp0__length2 = self->priv->lights_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_;
	return result;
}

static GObject*
board_view_gtk_real_get_light_at (BoardView* base,
                                  gint x,
                                  gint y)
{
	BoardViewGtk * self;
	GtkToggleButton** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GtkToggleButton* _tmp1_;
	GObject* _tmp2_;
	GObject* result = NULL;
	self = (BoardViewGtk*) base;
	_tmp0_ = self->priv->lights;
	_tmp0__length1 = self->priv->lights_length1;
	_tmp0__length2 = self->priv->lights_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = _g_object_ref0 ((GObject*) _tmp1_);
	result = _tmp2_;
	return result;
}

static void
board_view_gtk_real_increase_moves (BoardView* base)
{
	BoardViewGtk * self;
	self = (BoardViewGtk*) base;
	self->priv->_moves = self->priv->_moves + 1;
}

BoardViewGtk*
board_view_gtk_construct (GType object_type)
{
	BoardViewGtk * self = NULL;
	self = (BoardViewGtk*) g_object_new (object_type, NULL);
	return self;
}

BoardViewGtk*
board_view_gtk_new (void)
{
	return board_view_gtk_construct (TYPE_BOARD_VIEW_GTK);
}

static void
_board_view_gtk___lambda6_ (BoardViewGtk* self)
{
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
}

static void
__board_view_gtk___lambda6__board_view_completed (BoardView* _sender,
                                                  gpointer self)
{
	_board_view_gtk___lambda6_ ((BoardViewGtk*) self);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static GObject *
board_view_gtk_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BoardViewGtk * self;
	GtkStyleContext* _tmp0_;
	PuzzleGenerator* _tmp1_;
	GtkToggleButton** _tmp2_;
	GList* focus_list = NULL;
	GList* _tmp18_;
	parent_class = G_OBJECT_CLASS (board_view_gtk_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD_VIEW_GTK, BoardViewGtk);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "grid");
	gtk_grid_set_row_homogeneous ((GtkGrid*) self, TRUE);
	gtk_grid_set_column_homogeneous ((GtkGrid*) self, TRUE);
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 2);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 2);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 2);
	gtk_widget_set_size_request ((GtkWidget*) self, BOARD_VIEW_size * BOARD_VIEW_GTK_MIN_TOGGLE_SIZE, BOARD_VIEW_size * BOARD_VIEW_GTK_MIN_TOGGLE_SIZE);
	_tmp1_ = puzzle_generator_new (BOARD_VIEW_size);
	_g_object_unref0 (self->priv->puzzle_generator);
	self->priv->puzzle_generator = _tmp1_;
	_tmp2_ = g_new0 (GtkToggleButton*, (BOARD_VIEW_size * BOARD_VIEW_size) + 1);
	self->priv->lights = (_vala_array_free (self->priv->lights, self->priv->lights_length1 * self->priv->lights_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->lights = _tmp2_;
	self->priv->lights_length1 = BOARD_VIEW_size;
	self->priv->lights_length2 = BOARD_VIEW_size;
	focus_list = NULL;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = x;
					x = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				if (!(x < BOARD_VIEW_size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp5_ = FALSE;
						_tmp5_ = TRUE;
						while (TRUE) {
							GtkToggleButton** _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							GtkToggleButton* _tmp8_;
							GtkToggleButton** _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							GtkToggleButton* _tmp10_;
							GtkToggleButton** _tmp11_;
							gint _tmp11__length1;
							gint _tmp11__length2;
							GtkToggleButton* _tmp12_;
							GtkToggleButton** _tmp13_;
							gint _tmp13__length1;
							gint _tmp13__length2;
							GtkToggleButton* _tmp14_;
							GtkToggleButton** _tmp15_;
							gint _tmp15__length1;
							gint _tmp15__length2;
							GtkToggleButton* _tmp16_;
							GtkWidget* _tmp17_;
							if (!_tmp5_) {
								gint _tmp6_;
								_tmp6_ = y;
								y = _tmp6_ + 1;
							}
							_tmp5_ = FALSE;
							if (!(y < BOARD_VIEW_size)) {
								break;
							}
							_tmp7_ = self->priv->lights;
							_tmp7__length1 = self->priv->lights_length1;
							_tmp7__length2 = self->priv->lights_length2;
							_tmp8_ = (GtkToggleButton*) gtk_toggle_button_new ();
							g_object_ref_sink (_tmp8_);
							_g_object_unref0 (_tmp7_[(x * _tmp7__length2) + y]);
							_tmp7_[(x * _tmp7__length2) + y] = _tmp8_;
							_tmp9_ = self->priv->lights;
							_tmp9__length1 = self->priv->lights_length1;
							_tmp9__length2 = self->priv->lights_length2;
							_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
							gtk_widget_show ((GtkWidget*) _tmp10_);
							_tmp11_ = self->priv->lights;
							_tmp11__length1 = self->priv->lights_length1;
							_tmp11__length2 = self->priv->lights_length2;
							_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
							g_signal_connect_object (_tmp12_, "toggled", (GCallback) _board_view_handle_toggle_gtk_toggle_button_toggled, (BoardView*) self, 0);
							_tmp13_ = self->priv->lights;
							_tmp13__length1 = self->priv->lights_length1;
							_tmp13__length2 = self->priv->lights_length2;
							_tmp14_ = _tmp13_[(x * _tmp13__length2) + y];
							gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp14_, x, y, 1, 1);
							_tmp15_ = self->priv->lights;
							_tmp15__length1 = self->priv->lights_length1;
							_tmp15__length2 = self->priv->lights_length2;
							_tmp16_ = _tmp15_[(x * _tmp15__length2) + y];
							_tmp17_ = _g_object_ref0 ((GtkWidget*) _tmp16_);
							focus_list = g_list_append (focus_list, _tmp17_);
						}
					}
				}
			}
		}
	}
	_tmp18_ = focus_list;
	gtk_container_set_focus_chain ((GtkContainer*) self, _tmp18_);
	self->priv->_moves = 0;
	g_signal_connect_object ((BoardView*) self, "completed", (GCallback) __board_view_gtk___lambda6__board_view_completed, self, 0);
	gtk_widget_show ((GtkWidget*) self);
	(focus_list == NULL) ? NULL : (focus_list = (_g_list_free__g_object_unref0_ (focus_list), NULL));
	return obj;
}

static void
board_view_gtk_class_init (BoardViewGtkClass * klass,
                           gpointer klass_data)
{
	board_view_gtk_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BoardViewGtk_private_offset);
	G_OBJECT_CLASS (klass)->constructor = board_view_gtk_constructor;
	G_OBJECT_CLASS (klass)->finalize = board_view_gtk_finalize;
}

static void
board_view_gtk_board_view_interface_init (BoardViewIface * iface,
                                          gpointer iface_data)
{
	board_view_gtk_board_view_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_moves = (gint (*) (BoardView*)) board_view_gtk_real_get_moves;
	iface->toggle_light = (void (*) (BoardView*, gint, gint, gboolean)) board_view_gtk_real_toggle_light;
	iface->clear_level = (void (*) (BoardView*)) board_view_gtk_real_clear_level;
	iface->get_puzzle_generator = (PuzzleGenerator* (*) (BoardView*)) board_view_gtk_real_get_puzzle_generator;
	iface->is_light_active = (gboolean (*) (BoardView*, gint, gint)) board_view_gtk_real_is_light_active;
	iface->get_light_at = (GObject* (*) (BoardView*, gint, gint)) board_view_gtk_real_get_light_at;
	iface->increase_moves = (void (*) (BoardView*)) board_view_gtk_real_increase_moves;
}

static void
board_view_gtk_instance_init (BoardViewGtk * self,
                              gpointer klass)
{
	self->priv = board_view_gtk_get_instance_private (self);
	self->priv->_moves = 0;
}

static void
board_view_gtk_finalize (GObject * obj)
{
	BoardViewGtk * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD_VIEW_GTK, BoardViewGtk);
	_g_object_unref0 (self->priv->puzzle_generator);
	self->priv->lights = (_vala_array_free (self->priv->lights, self->priv->lights_length1 * self->priv->lights_length2, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (board_view_gtk_parent_class)->finalize (obj);
}

static GType
board_view_gtk_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoardViewGtkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) board_view_gtk_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoardViewGtk), 0, (GInstanceInitFunc) board_view_gtk_instance_init, NULL };
	static const GInterfaceInfo board_view_info = { (GInterfaceInitFunc) board_view_gtk_board_view_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType board_view_gtk_type_id;
	board_view_gtk_type_id = g_type_register_static (gtk_grid_get_type (), "BoardViewGtk", &g_define_type_info, 0);
	g_type_add_interface_static (board_view_gtk_type_id, TYPE_BOARD_VIEW, &board_view_info);
	BoardViewGtk_private_offset = g_type_add_instance_private (board_view_gtk_type_id, sizeof (BoardViewGtkPrivate));
	return board_view_gtk_type_id;
}

GType
board_view_gtk_get_type (void)
{
	static volatile gsize board_view_gtk_type_id__volatile = 0;
	if (g_once_init_enter (&board_view_gtk_type_id__volatile)) {
		GType board_view_gtk_type_id;
		board_view_gtk_type_id = board_view_gtk_get_type_once ();
		g_once_init_leave (&board_view_gtk_type_id__volatile, board_view_gtk_type_id);
	}
	return board_view_gtk_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

